% readmat1 -- reads a (list of) matrix(ces) in simple format 
%   mrows ncols
%   A11 A12 ... A1n
%   ...
%   Am1 Am2 ... Amn

function [A1,A2,A3,A4] = readmat1(file)
   A1 = [];
   A2 = [];
   A3 = [];
   A4 = [];
   if (nargin < 1) 
      error('Filename argument missing.');
   elseif (isstr(file)) 
      fid = fopen(file,'r');
      if (fid < 0) error(['Can not open file: ',file]); end
   elseif (file>=0 & file<256)
      fid = floor(file);
   else
      error('Argument must be a string.'); 
   end;
   if nargin<2, nmat=1; end;
   for k = 1:nargout
      % broken logic, but OK for now
      while 1
	 c2 = 0;
	 lbuf = fgetl(fid);
	 [s,c1] = sscanf(lbuf,'%s');
	 if c1==0, lbuf = fgetl(fid); end;
	 [mn,c2] = sscanf(lbuf,'%d %d');
	 % ['--',s,'--'],c1,c2
	 if c1==0 | c2==2, break; end;
      end
      if ~(c2==2), break; end
      m = mn(1); 
      n = mn(2);
      A = zeros(m,n);
      for i = 1:m
	 [R,count] = fscanf(fid,'%f',[1 n]);
	 if (~(count==n)) error(['Can not read file ',file,' line ',i]); end;
	 A(i,:) = R;
      end
#      lbuf = fgetl(fid)
      if k==1, A1 = A; 
      elseif k==2, A2 = A; 
      elseif k==3, A3 = A; 
      elseif k==4, A4 = A; 
      else error('readmat1: too many matrices');
      end
   end
   if (isstr(file)) fclose(fid); end;
end;
