% tests for profile Cholesky

function tst_profchol(prof)
   eps = 0;
   if nargin<1, prof = []; end
   n = 10;
   if size(prof,2)==1, n = prof; prof = []; end
   if isempty(prof), prof = max(1,ceil([1:n]-sqrt(n*abs(randn(1,n))))); end
   n = size(prof,2);
   seive = zeros(n);
   for i=1:n, seive(prof(i):i,i) = ones(i-prof(i)+1,1); end
   U = randn(2*n,n);
   b = randn(n,1);
   A = U'*U;
   A = A.*seive;
   t0=cputime;
   R0 = chol(A);
   dt=cputime-t0
   t0=cputime;
   [R1,p1] = profchol(A,[],eps);
   dt=cputime-t0
   [norm(A-triu(R0'*R0),'fro'), norm(R0-R1,'fro'), norm(prof-p1,'fro')]
   x0 = (A+triu(A,1)') \ b;
   % f0 = R0' \ b
   % x00 = R0 \ f0
   % x00-x0
   % norm(A*x0-b,'fro')
   f1 = proffsub(R1,p1,b);
   % R1'*f1-b
   x1 = profbsub(R1,p1,f1);
   % R1*x1-f1
   norm(x1-x0,'fro')

   bw = max([1:n]-prof)+1
   B = zeros(bw,n);
   for i=1:n, B(prof(i)-(i-bw):bw,i) = A(prof(i):i,i); end
   % B
   t0=cputime;
   [R2,p2] = profchol(B,[],eps);
   dt=cputime-t0
   f2 = proffsub(R2,p2,b);
   x2 = profbsub(R2,p2,f2);
   norm(x2-x0,'fro')

   p3 = cumsum([1:n]-prof+1);
   nz = p3(n)
   C = zeros(p3(n),1);
   for i=1:n, C((prof(i)-i:0)+p3(i)) = A(prof(i):i,i); end
   % C'
   t0=cputime;
   R3 = profchol(C,p3,eps);
   dt=cputime-t0
   % R3'
   f3 = proffsub(R3,p3,b);
   x3 = profbsub(R3,p3,f3);
   norm(x3-x0,'fro')
   
%end
   
